diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/app/Activity.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/Activity.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/app/Activity.java	2017-09-27 02:07:48.875736111 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/Activity.java	2017-09-21 13:22:46.105169000 +0900
@@ -25,7 +25,10 @@
 import android.annotation.NonNull;
 import android.annotation.Nullable;
 import android.annotation.StyleRes;
+import android.graphics.BitmapFactory;
+import android.os.AsyncTask;
 import android.os.PersistableBundle;
+import android.service.samd.SAMDManager;
 import android.transition.Scene;
 import android.transition.TransitionManager;
 import android.util.ArrayMap;
@@ -91,6 +94,7 @@
 import android.view.MenuItem;
 import android.view.MotionEvent;
 import com.android.internal.policy.PhoneWindow;
+
 import android.view.SearchEvent;
 import android.view.View;
 import android.view.View.OnCreateContextMenuListener;
@@ -104,7 +108,12 @@
 import android.view.accessibility.AccessibilityEvent;
 import android.widget.AdapterView;
 
+import java.io.ByteArrayOutputStream;
+import java.io.File;
 import java.io.FileDescriptor;
+import java.io.FileNotFoundException;
+import java.io.FileOutputStream;
+import java.io.IOException;
 import java.io.PrintWriter;
 import java.lang.annotation.Retention;
 import java.lang.annotation.RetentionPolicy;
@@ -672,6 +681,47 @@
         Window.Callback, KeyEvent.Callback,
         OnCreateContextMenuListener, ComponentCallbacks2,
         Window.OnWindowDismissedCallback {
+
+    class InitActivity extends AsyncTask<Void,Void,Boolean> {
+        @Override
+        protected void onPreExecute() {
+            super.onPreExecute();
+        }
+
+        @Override
+        protected Boolean doInBackground(Void... voids) {
+            boolean start = true;
+            //collaboroid
+            SAMDManager ss = (SAMDManager) getSystemService(Context.SAMD_SERVICE);
+            int stringId = getApplicationInfo().labelRes;
+            if(stringId == 0){
+                if(getApplicationInfo().nonLocalizedLabel != null){
+
+                }
+            }else{
+                if(!ss.getCurrentAppName().equals(getApplicationContext().getString(stringId))){
+                    //null
+                    start = ss.initialARTable(getApplicationContext().getString(stringId));
+                }
+            }
+            return start;
+        }
+
+        // AsyncTask.cancel(boolean) 메소드가 true 인자로
+        // 실행되면 호출되는 콜백.
+        // background 작업이 취소될때 꼭 해야될 작업은  여기에 구현.
+        @Override
+        protected void onCancelled() {
+            // TODO Auto-generated method stub
+            super.onCancelled();
+        }
+    }
+
+    public InitActivity initAsync;
+
+    public static ClassLoader ORIGINAL_LOADER;
+    public static ClassLoader CUSTOM_LOADER = null;
+
     private static final String TAG = "Activity";
     private static final boolean DEBUG_LIFECYCLE = false;
 
@@ -771,7 +821,7 @@
         private boolean mUpdated;
     }
     private final ArrayList<ManagedCursor> mManagedCursors =
-        new ArrayList<ManagedCursor>();
+            new ArrayList<ManagedCursor>();
 
     // protected by synchronized (this)
     int mResultCode = RESULT_CANCELED;
@@ -902,28 +952,69 @@
     @MainThread
     @CallSuper
     protected void onCreate(@Nullable Bundle savedInstanceState) {
-        if (DEBUG_LIFECYCLE) Slog.v(TAG, "onCreate " + this + ": " + savedInstanceState);
-        if (mLastNonConfigurationInstances != null) {
-            mFragments.restoreLoaderNonConfig(mLastNonConfigurationInstances.loaders);
-        }
-        if (mActivityInfo.parentActivityName != null) {
-            if (mActionBar == null) {
-                mEnableDefaultActionBarUp = true;
-            } else {
-                mActionBar.setDefaultDisplayHomeAsUpEnabled(true);
+        if(getApplicationInfo().isSAMDApp()){
+            boolean activityPop = false;
+            initAsync = new InitActivity();
+            try {
+                activityPop = initAsync.execute().get();
+            }catch(Exception e) {
+                e.printStackTrace();
+            }
+            if(activityPop){
+                SAMDManager ss = (SAMDManager) getSystemService(Context.SAMD_SERVICE);
+                ss.preSendDex(getLocalClassName(), getPackageName());
+
+                if (DEBUG_LIFECYCLE){
+                    Slog.v(TAG, "onCreate " + this + ": " + savedInstanceState);
+                }
+                if (mLastNonConfigurationInstances != null) {
+                    mFragments.restoreLoaderNonConfig(mLastNonConfigurationInstances.loaders);
+                }
+                if (mActivityInfo.parentActivityName != null) {
+                    if (mActionBar == null) {
+                        mEnableDefaultActionBarUp = true;
+                    } else {
+                        mActionBar.setDefaultDisplayHomeAsUpEnabled(true);
+                    }
+                }
+                if (savedInstanceState != null) {
+                    Parcelable p = savedInstanceState.getParcelable(FRAGMENTS_TAG);
+                    mFragments.restoreAllState(p, mLastNonConfigurationInstances != null
+                            ? mLastNonConfigurationInstances.fragments : null);
+                }
+                mFragments.dispatchCreate();
+                getApplication().dispatchActivityCreated(this, savedInstanceState);
+                if (mVoiceInteractor != null) {
+                    mVoiceInteractor.attachActivity(this);
+                }
+                mCalled = true;
             }
+        }else{
+            if (DEBUG_LIFECYCLE){
+                Slog.v(TAG, "onCreate " + this + ": " + savedInstanceState);
+            }
+            if (mLastNonConfigurationInstances != null) {
+                mFragments.restoreLoaderNonConfig(mLastNonConfigurationInstances.loaders);
+            }
+            if (mActivityInfo.parentActivityName != null) {
+                if (mActionBar == null) {
+                    mEnableDefaultActionBarUp = true;
+                } else {
+                    mActionBar.setDefaultDisplayHomeAsUpEnabled(true);
+                }
+            }
+            if (savedInstanceState != null) {
+                Parcelable p = savedInstanceState.getParcelable(FRAGMENTS_TAG);
+                mFragments.restoreAllState(p, mLastNonConfigurationInstances != null
+                        ? mLastNonConfigurationInstances.fragments : null);
+            }
+            mFragments.dispatchCreate();
+            getApplication().dispatchActivityCreated(this, savedInstanceState);
+            if (mVoiceInteractor != null) {
+                mVoiceInteractor.attachActivity(this);
+            }
+            mCalled = true;
         }
-        if (savedInstanceState != null) {
-            Parcelable p = savedInstanceState.getParcelable(FRAGMENTS_TAG);
-            mFragments.restoreAllState(p, mLastNonConfigurationInstances != null
-                    ? mLastNonConfigurationInstances.fragments : null);
-        }
-        mFragments.dispatchCreate();
-        getApplication().dispatchActivityCreated(this, savedInstanceState);
-        if (mVoiceInteractor != null) {
-            mVoiceInteractor.attachActivity(this);
-        }
-        mCalled = true;
     }
 
     /**
@@ -947,7 +1038,7 @@
      * @see #onPostCreate
      */
     public void onCreate(@Nullable Bundle savedInstanceState,
-            @Nullable PersistableBundle persistentState) {
+                         @Nullable PersistableBundle persistentState) {
         onCreate(savedInstanceState);
     }
 
@@ -974,7 +1065,7 @@
      * @param persistentState contains the persistable saved state
      */
     final void performRestoreInstanceState(Bundle savedInstanceState,
-            PersistableBundle persistentState) {
+                                           PersistableBundle persistentState) {
         onRestoreInstanceState(savedInstanceState, persistentState);
         if (savedInstanceState != null) {
             restoreManagedDialogs(savedInstanceState);
@@ -1002,6 +1093,7 @@
      * @see #onSaveInstanceState
      */
     protected void onRestoreInstanceState(Bundle savedInstanceState) {
+        //변화가 생긴이후로는 여기로 들어온다.
         if (mWindow != null) {
             Bundle windowState = savedInstanceState.getBundle(WINDOW_HIERARCHY_TAG);
             if (windowState != null) {
@@ -1032,7 +1124,7 @@
      * @see #onSaveInstanceState
      */
     public void onRestoreInstanceState(Bundle savedInstanceState,
-            PersistableBundle persistentState) {
+                                       PersistableBundle persistentState) {
         if (savedInstanceState != null) {
             onRestoreInstanceState(savedInstanceState);
         }
@@ -1123,7 +1215,7 @@
      * @see #onCreate
      */
     public void onPostCreate(@Nullable Bundle savedInstanceState,
-            @Nullable PersistableBundle persistentState) {
+                             @Nullable PersistableBundle persistentState) {
         onPostCreate(savedInstanceState);
     }
 
@@ -1652,9 +1744,17 @@
      */
     @CallSuper
     protected void onDestroy() {
-        if (DEBUG_LIFECYCLE) Slog.v(TAG, "onDestroy " + this);
+
+        if (DEBUG_LIFECYCLE) {
+            Slog.v(TAG, "onDestroy " + this);
+        }
         mCalled = true;
 
+//        if(getApplicationInfo().isRemoteApp()){
+//            Log.d("samd experiment","is remote app");
+//            initAsync.onCancelled();
+//        }
+
         // dismiss any dialogs we are managing.
         if (mManagedDialogs != null) {
             final int numDialogs = mManagedDialogs.size();
@@ -1963,7 +2063,7 @@
      */
     @Deprecated
     public final Cursor managedQuery(Uri uri, String[] projection, String selection,
-            String sortOrder) {
+                                     String sortOrder) {
         Cursor c = getContentResolver().query(uri, projection, selection, null, sortOrder);
         if (c != null) {
             startManagingCursor(c);
@@ -2003,7 +2103,7 @@
      */
     @Deprecated
     public final Cursor managedQuery(Uri uri, String[] projection, String selection,
-            String[] selectionArgs, String sortOrder) {
+                                     String[] selectionArgs, String sortOrder) {
         Cursor c = getContentResolver().query(uri, projection, selection, selectionArgs, sortOrder);
         if (c != null) {
             startManagingCursor(c);
@@ -2096,6 +2196,13 @@
         return getWindow().findViewById(id);
     }
 
+    @Nullable
+    public View findViewById(String name) {
+        int id = getResources().getABC().getIdFromName(name);
+        Log.d(TAG, "findViewById: " + id);
+        return getWindow().findViewById(id);
+    }
+
     /**
      * Retrieve a reference to this activity's ActionBar.
      *
@@ -2173,6 +2280,11 @@
         initWindowDecorActionBar();
     }
 
+    public void setContentView2(String layoutResKey) {
+        getWindow().setContentView2(layoutResKey);
+        initWindowDecorActionBar();
+    }
+
     /**
      * Set the activity content to an explicit view.  This view is placed
      * directly into the activity's view hierarchy.  It can itself be a complex
@@ -2349,18 +2461,18 @@
         // Some modes use a SpannableStringBuilder to track & dispatch input events
         // This list must remain in sync with the switch in onKeyDown()
         switch (mode) {
-        case DEFAULT_KEYS_DISABLE:
-        case DEFAULT_KEYS_SHORTCUT:
-            mDefaultKeySsb = null;      // not used in these modes
-            break;
-        case DEFAULT_KEYS_DIALER:
-        case DEFAULT_KEYS_SEARCH_LOCAL:
-        case DEFAULT_KEYS_SEARCH_GLOBAL:
-            mDefaultKeySsb = new SpannableStringBuilder();
-            Selection.setSelection(mDefaultKeySsb,0);
-            break;
-        default:
-            throw new IllegalArgumentException();
+            case DEFAULT_KEYS_DISABLE:
+            case DEFAULT_KEYS_SHORTCUT:
+                mDefaultKeySsb = null;      // not used in these modes
+                break;
+            case DEFAULT_KEYS_DIALER:
+            case DEFAULT_KEYS_SEARCH_LOCAL:
+            case DEFAULT_KEYS_SEARCH_GLOBAL:
+                mDefaultKeySsb = new SpannableStringBuilder();
+                Selection.setSelection(mDefaultKeySsb,0);
+                break;
+            default:
+                throw new IllegalArgumentException();
         }
     }
 
@@ -2428,17 +2540,17 @@
                     clearSpannable = true;
 
                     switch (mDefaultKeyMode) {
-                    case DEFAULT_KEYS_DIALER:
-                        Intent intent = new Intent(Intent.ACTION_DIAL,  Uri.parse("tel:" + str));
-                        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
-                        startActivity(intent);
-                        break;
-                    case DEFAULT_KEYS_SEARCH_LOCAL:
-                        startSearch(str, false, null, false);
-                        break;
-                    case DEFAULT_KEYS_SEARCH_GLOBAL:
-                        startSearch(str, false, null, true);
-                        break;
+                        case DEFAULT_KEYS_DIALER:
+                            Intent intent = new Intent(Intent.ACTION_DIAL,  Uri.parse("tel:" + str));
+                            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                            startActivity(intent);
+                            break;
+                        case DEFAULT_KEYS_SEARCH_LOCAL:
+                            startSearch(str, false, null, false);
+                            break;
+                        case DEFAULT_KEYS_SEARCH_GLOBAL:
+                            startSearch(str, false, null, true);
+                            break;
                     }
                 }
             }
@@ -2816,12 +2928,12 @@
 
         LayoutParams params = getWindow().getAttributes();
         boolean isFullScreen = (params.width == LayoutParams.MATCH_PARENT) &&
-            (params.height == LayoutParams.MATCH_PARENT);
+                (params.height == LayoutParams.MATCH_PARENT);
         event.setFullScreen(isFullScreen);
 
         CharSequence title = getTitle();
         if (!TextUtils.isEmpty(title)) {
-           event.getText().add(title);
+            event.getText().add(title);
         }
 
         return true;
@@ -3609,7 +3721,7 @@
      * @see #onSearchRequested
      */
     public void startSearch(@Nullable String initialQuery, boolean selectInitialQuery,
-            @Nullable Bundle appSearchData, boolean globalSearch) {
+                            @Nullable Bundle appSearchData, boolean globalSearch) {
         ensureSearchManager();
         mSearchManager.startSearch(initialQuery, selectInitialQuery, getComponentName(),
                 appSearchData, globalSearch);
@@ -3716,7 +3828,7 @@
 
     @Override
     protected void onApplyThemeResource(Resources.Theme theme, @StyleRes int resid,
-            boolean first) {
+                                        boolean first) {
         if (mParent == null) {
             super.onApplyThemeResource(theme, resid, first);
         } else {
@@ -3846,7 +3958,7 @@
      * @see #requestPermissions(String[], int)
      */
     public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions,
-            @NonNull int[] grantResults) {
+                                           @NonNull int[] grantResults) {
         /* callback - no nothing */
     }
 
@@ -3927,13 +4039,13 @@
     public void startActivityForResult(Intent intent, int requestCode, @Nullable Bundle options) {
         if (mParent == null) {
             Instrumentation.ActivityResult ar =
-                mInstrumentation.execStartActivity(
-                    this, mMainThread.getApplicationThread(), mToken, this,
-                    intent, requestCode, options);
+                    mInstrumentation.execStartActivity(
+                            this, mMainThread.getApplicationThread(), mToken, this,
+                            intent, requestCode, options);
             if (ar != null) {
                 mMainThread.sendActivityResult(
-                    mToken, mEmbeddedID, requestCode, ar.getResultCode(),
-                    ar.getResultData());
+                        mToken, mEmbeddedID, requestCode, ar.getResultCode(),
+                        ar.getResultData());
             }
             if (requestCode >= 0) {
                 // If this start is requesting a result, we can avoid making
@@ -3985,7 +4097,7 @@
      * @hide Implement to provide correct calling token.
      */
     public void startActivityForResultAsUser(Intent intent, int requestCode,
-            @Nullable Bundle options, UserHandle user) {
+                                             @Nullable Bundle options, UserHandle user) {
         if (mParent != null) {
             throw new RuntimeException("Can't be called from a child");
         }
@@ -3994,7 +4106,7 @@
                 options, user);
         if (ar != null) {
             mMainThread.sendActivityResult(
-                mToken, mEmbeddedID, requestCode, ar.getResultCode(), ar.getResultData());
+                    mToken, mEmbeddedID, requestCode, ar.getResultCode(), ar.getResultData());
         }
         if (requestCode >= 0) {
             // If this start is requesting a result, we can avoid making
@@ -4030,8 +4142,8 @@
                         intent, -1, options, user);
         if (ar != null) {
             mMainThread.sendActivityResult(
-                mToken, mEmbeddedID, -1, ar.getResultCode(),
-                ar.getResultData());
+                    mToken, mEmbeddedID, -1, ar.getResultCode(),
+                    ar.getResultData());
         }
         cancelInputsAndStartExitTransition(options);
     }
@@ -4052,7 +4164,7 @@
      * @hide
      */
     public void startActivityAsCaller(Intent intent, @Nullable Bundle options,
-            boolean ignoreTargetSecurity, int userId) {
+                                      boolean ignoreTargetSecurity, int userId) {
         if (mParent != null) {
             throw new RuntimeException("Can't be called from a child");
         }
@@ -4062,8 +4174,8 @@
                         intent, -1, options, ignoreTargetSecurity, userId);
         if (ar != null) {
             mMainThread.sendActivityResult(
-                mToken, mEmbeddedID, -1, ar.getResultCode(),
-                ar.getResultData());
+                    mToken, mEmbeddedID, -1, ar.getResultCode(),
+                    ar.getResultData());
         }
         cancelInputsAndStartExitTransition(options);
     }
@@ -4084,7 +4196,7 @@
      * @param extraFlags Always set to 0.
      */
     public void startIntentSenderForResult(IntentSender intent, int requestCode,
-            @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags)
+                                           @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags)
             throws IntentSender.SendIntentException {
         startIntentSenderForResult(intent, requestCode, fillInIntent, flagsMask,
                 flagsValues, extraFlags, null);
@@ -4116,8 +4228,8 @@
      * override any that conflict with those given by the IntentSender.
      */
     public void startIntentSenderForResult(IntentSender intent, int requestCode,
-            @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags,
-            Bundle options) throws IntentSender.SendIntentException {
+                                           @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags,
+                                           Bundle options) throws IntentSender.SendIntentException {
         if (mParent == null) {
             startIntentSenderForResultInner(intent, requestCode, fillInIntent,
                     flagsMask, flagsValues, this, options);
@@ -4133,8 +4245,8 @@
     }
 
     private void startIntentSenderForResultInner(IntentSender intent, int requestCode,
-            Intent fillInIntent, int flagsMask, int flagsValues, Activity activity,
-            Bundle options)
+                                                 Intent fillInIntent, int flagsMask, int flagsValues, Activity activity,
+                                                 Bundle options)
             throws IntentSender.SendIntentException {
         try {
             String resolvedType = null;
@@ -4144,9 +4256,9 @@
                 resolvedType = fillInIntent.resolveTypeIfNeeded(getContentResolver());
             }
             int result = ActivityManagerNative.getDefault()
-                .startActivityIntentSender(mMainThread.getApplicationThread(), intent,
-                        fillInIntent, resolvedType, mToken, activity.mEmbeddedID,
-                        requestCode, flagsMask, flagsValues, options);
+                    .startActivityIntentSender(mMainThread.getApplicationThread(), intent,
+                            fillInIntent, resolvedType, mToken, activity.mEmbeddedID,
+                            requestCode, flagsMask, flagsValues, options);
             if (result == ActivityManager.START_CANCELED) {
                 throw new IntentSender.SendIntentException();
             }
@@ -4272,7 +4384,7 @@
      * @param extraFlags Always set to 0.
      */
     public void startIntentSender(IntentSender intent,
-            @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags)
+                                  @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags)
             throws IntentSender.SendIntentException {
         startIntentSender(intent, fillInIntent, flagsMask, flagsValues,
                 extraFlags, null);
@@ -4299,8 +4411,8 @@
      * override any that conflict with those given by the IntentSender.
      */
     public void startIntentSender(IntentSender intent,
-            @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags,
-            Bundle options) throws IntentSender.SendIntentException {
+                                  @Nullable Intent fillInIntent, int flagsMask, int flagsValues, int extraFlags,
+                                  Bundle options) throws IntentSender.SendIntentException {
         if (options != null) {
             startIntentSenderForResult(intent, -1, fillInIntent, flagsMask,
                     flagsValues, extraFlags, options);
@@ -4362,7 +4474,7 @@
      * @see #startActivityForResult
      */
     public boolean startActivityIfNeeded(@NonNull Intent intent, int requestCode,
-            @Nullable Bundle options) {
+                                         @Nullable Bundle options) {
         if (mParent == null) {
             int result = ActivityManager.START_RETURN_INTENT_TO_CALLER;
             try {
@@ -4373,10 +4485,10 @@
                 intent.migrateExtraStreamToClipData();
                 intent.prepareToLeaveProcess();
                 result = ActivityManagerNative.getDefault()
-                    .startActivity(mMainThread.getApplicationThread(), getBasePackageName(),
-                            intent, intent.resolveTypeIfNeeded(getContentResolver()), mToken,
-                            mEmbeddedID, requestCode, ActivityManager.START_FLAG_ONLY_IF_NEEDED,
-                            null, options);
+                        .startActivity(mMainThread.getApplicationThread(), getBasePackageName(),
+                                intent, intent.resolveTypeIfNeeded(getContentResolver()), mToken,
+                                mEmbeddedID, requestCode, ActivityManager.START_FLAG_ONLY_IF_NEEDED,
+                                null, options);
             } catch (RemoteException e) {
                 // Empty
             }
@@ -4397,7 +4509,7 @@
         }
 
         throw new UnsupportedOperationException(
-            "startActivityIfNeeded can only be called from a top-level activity");
+                "startActivityIfNeeded can only be called from a top-level activity");
     }
 
     /**
@@ -4443,7 +4555,7 @@
                 intent.migrateExtraStreamToClipData();
                 intent.prepareToLeaveProcess();
                 return ActivityManagerNative.getDefault()
-                    .startNextMatchingActivity(mToken, intent, options);
+                        .startNextMatchingActivity(mToken, intent, options);
             } catch (RemoteException e) {
                 // Empty
             }
@@ -4451,7 +4563,7 @@
         }
 
         throw new UnsupportedOperationException(
-            "startNextMatchingActivity can only be called from a top-level activity");
+                "startNextMatchingActivity can only be called from a top-level activity");
     }
 
     /**
@@ -4468,7 +4580,7 @@
      * @see #startActivityForResult
      */
     public void startActivityFromChild(@NonNull Activity child, Intent intent,
-            int requestCode) {
+                                       int requestCode) {
         startActivityFromChild(child, intent, requestCode, null);
     }
 
@@ -4492,15 +4604,15 @@
      * @see #startActivityForResult
      */
     public void startActivityFromChild(@NonNull Activity child, Intent intent,
-            int requestCode, @Nullable Bundle options) {
+                                       int requestCode, @Nullable Bundle options) {
         Instrumentation.ActivityResult ar =
-            mInstrumentation.execStartActivity(
-                this, mMainThread.getApplicationThread(), mToken, child,
-                intent, requestCode, options);
+                mInstrumentation.execStartActivity(
+                        this, mMainThread.getApplicationThread(), mToken, child,
+                        intent, requestCode, options);
         if (ar != null) {
             mMainThread.sendActivityResult(
-                mToken, child.mEmbeddedID, requestCode,
-                ar.getResultCode(), ar.getResultData());
+                    mToken, child.mEmbeddedID, requestCode,
+                    ar.getResultCode(), ar.getResultData());
         }
         cancelInputsAndStartExitTransition(options);
     }
@@ -4519,7 +4631,7 @@
      * @see Fragment#startActivityForResult
      */
     public void startActivityFromFragment(@NonNull Fragment fragment, Intent intent,
-            int requestCode) {
+                                          int requestCode) {
         startActivityFromFragment(fragment, intent, requestCode, null);
     }
 
@@ -4544,7 +4656,7 @@
      * @see Fragment#startActivityForResult
      */
     public void startActivityFromFragment(@NonNull Fragment fragment, Intent intent,
-            int requestCode, @Nullable Bundle options) {
+                                          int requestCode, @Nullable Bundle options) {
         startActivityForResult(fragment.mWho, intent, requestCode, options);
     }
 
@@ -4559,13 +4671,13 @@
             intent.putExtra(Intent.EXTRA_REFERRER, referrer);
         }
         Instrumentation.ActivityResult ar =
-            mInstrumentation.execStartActivity(
-                this, mMainThread.getApplicationThread(), mToken, who,
-                intent, requestCode, options);
+                mInstrumentation.execStartActivity(
+                        this, mMainThread.getApplicationThread(), mToken, who,
+                        intent, requestCode, options);
         if (ar != null) {
             mMainThread.sendActivityResult(
-                mToken, who, requestCode,
-                ar.getResultCode(), ar.getResultData());
+                    mToken, who, requestCode,
+                    ar.getResultCode(), ar.getResultData());
         }
         cancelInputsAndStartExitTransition(options);
     }
@@ -4583,8 +4695,8 @@
      * int, Intent, int, int, int, Bundle)} with no options.
      */
     public void startIntentSenderFromChild(Activity child, IntentSender intent,
-            int requestCode, Intent fillInIntent, int flagsMask, int flagsValues,
-            int extraFlags)
+                                           int requestCode, Intent fillInIntent, int flagsMask, int flagsValues,
+                                           int extraFlags)
             throws IntentSender.SendIntentException {
         startIntentSenderFromChild(child, intent, requestCode, fillInIntent,
                 flagsMask, flagsValues, extraFlags, null);
@@ -4597,8 +4709,8 @@
      * for more information.
      */
     public void startIntentSenderFromChild(Activity child, IntentSender intent,
-            int requestCode, Intent fillInIntent, int flagsMask, int flagsValues,
-            int extraFlags, @Nullable Bundle options)
+                                           int requestCode, Intent fillInIntent, int flagsMask, int flagsValues,
+                                           int extraFlags, @Nullable Bundle options)
             throws IntentSender.SendIntentException {
         startIntentSenderForResultInner(intent, requestCode, fillInIntent,
                 flagsMask, flagsValues, child, options);
@@ -4960,7 +5072,7 @@
         if (mParent == null) {
             try {
                 ActivityManagerNative.getDefault()
-                    .finishSubActivity(mToken, mEmbeddedID, requestCode);
+                        .finishSubActivity(mToken, mEmbeddedID, requestCode);
             } catch (RemoteException e) {
                 // Empty
             }
@@ -4980,7 +5092,7 @@
     public void finishActivityFromChild(@NonNull Activity child, int requestCode) {
         try {
             ActivityManagerNative.getDefault()
-                .finishSubActivity(mToken, child.mEmbeddedID, requestCode);
+                    .finishSubActivity(mToken, child.mEmbeddedID, requestCode);
         } catch (RemoteException e) {
             // Empty
         }
@@ -5092,16 +5204,16 @@
      * @see PendingIntent
      */
     public PendingIntent createPendingResult(int requestCode, @NonNull Intent data,
-            @PendingIntent.Flags int flags) {
+                                             @PendingIntent.Flags int flags) {
         String packageName = getPackageName();
         try {
             data.prepareToLeaveProcess();
             IIntentSender target =
-                ActivityManagerNative.getDefault().getIntentSender(
-                        ActivityManager.INTENT_SENDER_ACTIVITY_RESULT, packageName,
-                        mParent == null ? mToken : mParent.mToken,
-                        mEmbeddedID, requestCode, new Intent[] { data }, null, flags, null,
-                        UserHandle.myUserId());
+                    ActivityManagerNative.getDefault().getIntentSender(
+                            ActivityManager.INTENT_SENDER_ACTIVITY_RESULT, packageName,
+                            mParent == null ? mToken : mParent.mToken,
+                            mEmbeddedID, requestCode, new Intent[] { data }, null, flags, null,
+                            UserHandle.myUserId());
             return target != null ? new PendingIntent(target) : null;
         } catch (RemoteException e) {
             // Empty
@@ -5165,7 +5277,7 @@
     public int getTaskId() {
         try {
             return ActivityManagerNative.getDefault()
-                .getTaskForActivity(mToken, false);
+                    .getTaskForActivity(mToken, false);
         } catch (RemoteException e) {
             return -1;
         }
